/**************************************************************************/
/******************** fcal.c *** $B>.7?$N%+%l%s%@!<(B *************************/
/********* (c) Copyright 1999 H.Funayama, All Rights Reserved *************/
/***************** last modified **** Sat Jan 15 06:32:00 2000 ************/
/**************************************************************************/


#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "fcal.h"
#define ON 1


/** $B%9%?%F%#%C%/4X?t$N@k8@(B **/
static void makedate(int, int);
static void colholyday(int, int);
static void delholyday(int, int);
static void colnowday();
static void delnowday();
static void colweekend();
static void enredday(int);


/** $B%9%?%F%#%C%/30ItJQ?t(B **/
static Widget month, day[40];
static int n_year;
static int n_month;
static int n_start;
static int n_end;
static int flag=0;
static TIME now;


/* ---------------------------------------------------------------------- */
/*                           $B%3!<%k%P%C%/4X?t(B                             */
/*                               $B:8%\%?%s(B                                 */
/* ---------------------------------------------------------------------- */
static void chmonthL_cb()
{
    char datetmp[9];

    delholyday(n_month, n_start);

    switch (n_month) {
    case 2: case 4: case 6: case 8: case 9: case 11: case 1:
	n_start -= 3;
	n_end = 31;
	break;
    case 3:
	if ((n_year % 4 == 0 && n_year % 100 != 0) || n_year % 400 == 0) {
	    n_start -= 1;
	    n_end = 29;
        } else
	    n_end = 28;
        break;
    case 5: case 7: case 10: case 12:
	n_start -= 2;
	n_end = 30;
        break;
    }
    if (n_start < 0)
	n_start += 7;

    if (n_month == 1) {
	n_year -= 1;
	n_month = 12;
    } else
	n_month -= 1;

    sprintf (datetmp, "%d  %d", n_year, n_month);
    XtVaSetValues(month, XtNlabel, datetmp, NULL);

    makedate(n_start, n_end);

    if (n_month == now.month && n_year == now.year)
	colnowday();
    else
	delnowday();
    colweekend();
    colholyday(n_month, n_start);
}

/* ---------------------------------------------------------------------- */
/*                           $B%3!<%k%P%C%/4X?t(B                             */
/*                               $B1&%\%?%s(B                                 */
/* ---------------------------------------------------------------------- */
static void chmonthR_cb()
{
    char datetmp[9];

    delholyday(n_month, n_start);

    switch (n_month) {
    case 1:
	n_start += 3;
	if ((n_year % 4 == 0 && n_year % 100 != 0) || n_year % 400 == 0)
	    n_end = 29;
	else
	    n_end = 28;
	break;
    case 3: case 5: case 8: case 10:
	n_start += 3;
	n_end = 30;
	break;
    case 2:
	if ((n_year % 4 == 0 && n_year % 100 != 0) || n_year % 400 == 0)
	    n_start += 1;
	n_end = 31;
        break;
    case 4: case 6: case 9: case 11:
	n_start += 2;
	n_end = 31;
	break;
    case 7: case 12:
	n_start += 3;
	n_end = 31;
	break;
    }
    if (n_start > 6)
	n_start -= 7;

    if (n_month == 12) {
	n_year += 1;
	n_month = 1;
    } else
	n_month +=1;

    sprintf (datetmp, "%d  %d", n_year, n_month);
    XtVaSetValues(month, XtNlabel, datetmp, NULL);

    makedate(n_start, n_end);

    if (n_month == now.month && n_year == now.year)
	colnowday();
    else
	delnowday();
    colweekend();
    colholyday(n_month, n_start);
}

/* ---------------------------------------------------------------------- */
/*                           $B%3!<%k%P%C%/4X?t(B                             */
/*                          $B8=:_7n$KLa$k%\%?%s(B                            */
/* ---------------------------------------------------------------------- */
static void backnow_cb()
{
    char daytmp[8];

    delnowday();
    delholyday( n_month, n_start);

    gettime(&now);
    n_year = now.year;
    n_month = now.month;
    n_start = now.start;
    n_end = now.end;

    sprintf(daytmp, "%d %d", now.year, now.month);
    XtVaSetValues(month, XtNlabel, daytmp, NULL);

    makedate(now.start, now.end);

    colnowday();
    colweekend();
    colholyday(now.month, now.start);
}


/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*              $B7n$N3+;OMKF|$H=*N;F|$r$b$i$C$FF|IU$rJB$Y$k(B                */
/* ---------------------------------------------------------------------- */
static void makedate(int start, int end)
{
    int i;
    char daytmp[3];

    if (start != 0) {
        for (i=0; i<start; i++)
            XtVaSetValues( day[i], XtNlabel, "  ", NULL);
    }
    for (i=start; i<(start + end); i++) {
        sprintf(daytmp, "%2d", i - start + 1);
        XtVaSetValues( day[i], XtNlabel, daytmp, NULL);
    }
    for (i=(start + end); i<40; i++)
        XtVaSetValues( day[i], XtNlabel, "  ", NULL);
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                            day[]$B$r@V$/$9$k(B                             */
/* ---------------------------------------------------------------------- */
static void enredday(daynum)
{
    XColor red;
    Colormap cm;
    red.red=65535L; red.green=0L; red.blue=0L;
/*    red.red=65535L; red.green=30000L; red.blue=30000L;*/

    cm = DefaultColormap( XtDisplay(day[daynum]), 0);
    XAllocColor( XtDisplay(day[daynum]), cm, &red);
    XtVaSetValues( day[daynum],
		   XtNforeground, red.pixel,
		   NULL);
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                      day[]$B$r@V$/$7$?$N$rC&?'$9$k(B                       */
/* ---------------------------------------------------------------------- */
static void disredday(daynum)
{
    XColor tmp_f;

    XtVaGetValues( day[39],
		   XtNforeground, &tmp_f.pixel,
		   NULL);
    XtVaSetValues( day[daynum],
		   XtNforeground, tmp_f.pixel,
		   NULL);
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                          $B=KF|$r@V$/Ce?'$9$k(B                            */
/* ---------------------------------------------------------------------- */
static void colholyday(int month, int start)
{
    int i;

    switch (month) {
    case 1:
	enredday(start);
	if (start % 7 == 0)
	    enredday(start + 1);
	if (start < 2)
	    enredday(8);
	else
	    enredday(15);
	break;
    case 2:
	enredday(10 + start);
	if ((10 + start)% 7 == 0)
	    enredday(11 + start);
	break;
    case 3:
	enredday(19 + start);   /* $B=UJ,$NF|(B */
	break;
    case 4:
	enredday(28 + start);
	if ((28 + start)% 7 == 0)
	    enredday(29 + start);
	break;
    case 5:
	for (i=2; i<5; i++)
	    enredday(i + start);
	if ((4 + start)% 7 == 0)
	    enredday(5 + start);
	break;
    case 7:
	enredday(19 + start);
	if ((19 + start)% 7 == 0)
	    enredday(20 + start);
	break;
    case 9:
	enredday(14 + start);
	if ((14 + start)% 7 == 0)
	    enredday(15 + start);
	enredday(22 + start);    /* $B=)J,$NF|(B */
	break;
    case 10:
	if (start < 2)
	    enredday(8);
	else
	    enredday(15);
	break;
    case 11:
	enredday(2 + start);
	if ((2 + start)% 7 == 0)
	    enredday(3 + start);
	enredday(22 + start);
	if ((22 + start)% 7 == 0)
	    enredday(23 + start);
	break;
    case 12:
	enredday(22 + start);
	if ((22 + start)% 7 == 0)
	    enredday(23 + start);
	break;
    }
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                            $B=KF|$rC&?'$9$k(B                              */
/* ---------------------------------------------------------------------- */
static void delholyday(int month, int start)
{
    int i;

    switch (month) {
    case 1:
	disredday(start);
	if (start % 7 == 0)
	    disredday(start + 1);
	if (start < 2)
	    disredday(8);
	else
	    disredday(15);
	break;
    case 2:
	disredday(10 + start);
	if ((10 + start)% 7 == 0)
	    disredday(11 + start);
	break;
    case 3:
	disredday(19 + start);   /* $B=UJ,$NF|(B */
	break;
    case 4:
	disredday(28 + start);
	if ((28 + start)% 7 == 0)
	    disredday(29 + start);
	break;
    case 5:
	for (i=2; i<5; i++)
	    disredday(i + start);
	if ((4 + start)% 7 == 0)
	    disredday(5 + start);
	break;
    case 7:
	disredday(19 + start);
	if ((19 + start)% 7 == 0)
	    disredday(20 + start);
	break;
    case 9:
	disredday(14 + start);
	if ((14 + start)% 7 == 0)
	    disredday(15 + start);
	disredday(22 + start);    /* $B=)J,$NF|(B */
	break;
    case 10:
	if (start < 2)
	    disredday(8);
	else
	    disredday(15);
	break;
    case 11:
	disredday(2 + start);
	if ((2 + start)% 7 == 0)
	    disredday(3 + start);
	disredday(22 + start);
	if ((22 + start)% 7 == 0)
	    disredday(23 + start);
	break;
    case 12:
	disredday(22 + start);
	if ((22 + start)% 7 == 0)
	    disredday(23 + start);
	break;
    }
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                           $B8=:_F|$rCe?'$9$k(B                             */
/* ---------------------------------------------------------------------- */
static void colnowday()
{
    XColor tmp_b, tmp_f;

    XtVaGetValues( day[39],
		   XtNforeground, &tmp_f.pixel,
		   XtNbackground, &tmp_b.pixel,
		   NULL);
    XtVaSetValues( day[now.date + now.start -1],
 		   XtNforeground, tmp_b.pixel,
 		   XtNbackground, tmp_f.pixel,
		   NULL);
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                           $B8=:_F|$rC&?'$9$k(B                             */
/* ---------------------------------------------------------------------- */
static void delnowday()
{
    XColor tmp_b, tmp_f;

    XtVaGetValues( day[39],
		   XtNbackground, &tmp_b.pixel,
		   XtNforeground, &tmp_f.pixel,
		   NULL);
    XtVaSetValues( day[now.date + now.start -1],
		   XtNbackground, tmp_b.pixel,
		   XtNforeground, tmp_f.pixel,
		   NULL);
}

/* ---------------------------------------------------------------------- */
/*                           $B%9%?%F%#%C%/4X?t(B                             */
/*                         $BF|!&EZMKF|$rCe?'$9$k(B                           */
/* ---------------------------------------------------------------------- */
static void colweekend()
{
    int i;
    XColor blue;
    Colormap cm;

/* $BF|MK$NCe?'(B */
    for (i=0; i<=35; i+=7)
	enredday(i);
/* $BEZMK$NCe?'(B */
    for (i=6; i<=34; i+=7) {
	cm = DefaultColormap( XtDisplay(day[i]), 0);
	blue.red=0L; blue.green=0L; blue.blue=65535L;
	XAllocColor(XtDisplay(day[i]), cm, &blue);
	XtVaSetValues( day[i],
		       XtNforeground, blue.pixel,
		       NULL);
    }
}

/**************************************************************************/
/*                              $B%a%$%s(B                                    */
/**************************************************************************/
int main(int argc, char **argv)
{
    XtAppContext app;
    Widget top, form, week[7], botanL, botanR, backnow;
    XColor red, blue;
    Colormap cm;
    int i;
    char daytmp[3];
    char datetmp[9];
    char weeklabel[7][4] = {"Su", "Mo", "Tu", "We", " Th", " Fr", "Sa"};


    /* $B%j%=!<%9(B */
    static String fallback_resources[] = {
	"*title: fcal",
	"*geometry: 117x112",
	"*font: -adobe-helvetica-bold-r-*-*-10-*-*-*-*-*-iso8859-1",
	"*top: ChainTop",
	"*bottom: ChainTop",
	"*left: ChainLeft",
	"*right: ChainRight",
	"*width: 11",
	"*height: 10",
	"*month.width: 71",
	"*backnow.width: 21",
	"*borderWidth: 0",
	"*background: black",
	"*foreground: RoyalBlue",
	"*month.foreground: white",
	NULL
    };


    top = XtVaAppInitialize(&app, "fcal", NULL, 0, &argc, argv, fallback_resources, NULL);

    form = XtVaCreateManagedWidget("form", formWidgetClass, top, NULL);


    /* $B%m!<%+%k$N%+%l%s%@!<;~4V$r<hF@(B */
    gettime(&now);
    if (flag == 0) {
	n_year = now.year;
	n_month = now.month;
	n_start = now.start;
	flag = ON;
    }


    /* $B:8%\%?%s$N:n@.(B */
    botanL = XtVaCreateManagedWidget("botanL", commandWidgetClass, form,
				     XtNlabel, "<",
				     NULL);
    XtAddCallback(botanL, XtNcallback, chmonthL_cb, NULL);


    /* $B@>Nq$H7n$N:n@.(B */
    sprintf (datetmp, "%d  %d", now.year, now.month);
    month = XtVaCreateManagedWidget("month", labelWidgetClass, form,
				    XtNlabel, datetmp,
				    XtNfromHoriz, botanL,
				    NULL);


    /* $B1&%\%?%s$N:n@.(B */
    botanR = XtVaCreateManagedWidget("botanR", commandWidgetClass, form,
				     XtNlabel, ">",
				     XtNfromHoriz, month,
				     NULL);
    XtAddCallback(botanR, XtNcallback, chmonthR_cb, NULL);


    /* $BMKF|%i%Y%k$N:n@.(B */
    week[0] = XtVaCreateManagedWidget("week[0]", labelWidgetClass, form,
				      XtNlabel, weeklabel[0],
				      XtNfromVert, month,
				      NULL);
    for (i=1; i<7; i++) {
	week[i] = XtVaCreateManagedWidget("week[i]", labelWidgetClass, form,
					  XtNlabel, weeklabel[i],
					  XtNfromVert, month,
					  XtNfromHoriz, week[i-1],
					  NULL);
    }
    cm = DefaultColormap( XtDisplay(week[0]), 0);
    red.red=65535L; red.green=0L; red.blue=0L;
/*    red.red=65535L; red.green=30000L; red.blue=30000L;*/
    XAllocColor(XtDisplay(week[0]), cm, &red);
    XtVaSetValues(week[0], XtNforeground, red.pixel, NULL);
    cm = DefaultColormap( XtDisplay(week[6]), 0);
    blue.red=0L; blue.green=0L; blue.blue=65535L;
/*    blue.red=40000L; blue.green=40000L; blue.blue=65535L;*/
    XAllocColor(XtDisplay(week[6]), cm, &blue);
    XtVaSetValues(week[6], XtNforeground, blue.pixel, NULL);


    /* $BF|%i%Y%k$N:n@.(B */
    /* $B<B9T;~$K%i%Y%kJ8;z$rM?$($k!%$3$&$7$J$$$H$&$^$/$$$+$J$$(B */
    if (now.start != 0) {
	day[0] = XtVaCreateManagedWidget("day[0]", labelWidgetClass, form,
					 XtNlabel, "  ",
					 XtNfromVert, week[0],
					 NULL);
	for (i=1; i<now.start; i++) {
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, "  ",
					     XtNfromVert, week[i],
					     XtNfromHoriz, day[i-1],
					     NULL);
	}
	for (i=now.start; i<7; i++) {
	    sprintf(daytmp, "%2d", i - now.start + 1);
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, daytmp,
					     XtNfromVert, week[i],
					     XtNfromHoriz, day[i-1],
					     NULL);
	}
    }
    else {
	day[0] = XtVaCreateManagedWidget("day[0]", labelWidgetClass, form,
					 XtNlabel, " 1",
					 XtNfromVert, week[0],
					 NULL);
	for (i=1; i<7; i++) {
	    sprintf(daytmp, "%2d", i + 1);
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, daytmp,
					     XtNfromVert, week[i],
					     XtNfromHoriz, day[i-1],
					     NULL);
	}
    }

    for (i=7; i<(now.start + now.end); i++) {
	sprintf(daytmp, "%2d", i - now.start + 1);
	if ((i % 7) == 0) {
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, daytmp,
					     XtNfromVert, day[i-7],
					     NULL);
	}
	else {
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, daytmp,
					     XtNfromVert, day[i-7],
					     XtNfromHoriz, day[i-1],
					     NULL);
	}
    }

    for (i=(now.start + now.end); i<40; i++) {
	if ((i % 7) == 0) {
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, "  ",
					     XtNfromVert, day[i-7],
					     NULL);
 	}
 	else {
	    day[i] = XtVaCreateManagedWidget("day[i]", labelWidgetClass, form,
					     XtNlabel, "  ",
					     XtNfromVert, day[i-7],
					     XtNfromHoriz, day[i-1],
					     NULL);
	}
    }

    /* $B8=:_F|$NCe?'(B */
    colnowday();
    /* $BEZF|$NCe?'(B */
    colweekend();
    /* $B=KF|$NCe?'(B */
    colholyday(now.month, now.start);


    /* $B8=:_7n$KLa$k%\%?%s$N:n@.(B */
    backnow = XtVaCreateManagedWidget("backnow", commandWidgetClass, form,
				      XtNlabel, "back",
				      XtNfromVert, day[34],
				      XtNfromHoriz, day[39],
				      NULL);
    XtAddCallback(backnow, XtNcallback, backnow_cb, NULL);



    XtRealizeWidget(top);

    XtAppMainLoop(app);

    return 0;
}
